/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the SalesforceDestinationAllOf type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &SalesforceDestinationAllOf{}

// SalesforceDestinationAllOf struct for SalesforceDestinationAllOf
type SalesforceDestinationAllOf struct {
	OAuthId    *int32  `json:"o_auth_id,omitempty"`
	Instance   *string `json:"instance,omitempty"`
	ApiVersion *string `json:"api_version,omitempty"`
	Object     *string `json:"object,omitempty"`
}

// NewSalesforceDestinationAllOf instantiates a new SalesforceDestinationAllOf object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewSalesforceDestinationAllOf() *SalesforceDestinationAllOf {
	this := SalesforceDestinationAllOf{}
	return &this
}

// NewSalesforceDestinationAllOfWithDefaults instantiates a new SalesforceDestinationAllOf object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewSalesforceDestinationAllOfWithDefaults() *SalesforceDestinationAllOf {
	this := SalesforceDestinationAllOf{}
	return &this
}

// GetOAuthId returns the OAuthId field value if set, zero value otherwise.
func (o *SalesforceDestinationAllOf) GetOAuthId() int32 {
	if o == nil || IsNil(o.OAuthId) {
		var ret int32
		return ret
	}
	return *o.OAuthId
}

// GetOAuthIdOk returns a tuple with the OAuthId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SalesforceDestinationAllOf) GetOAuthIdOk() (*int32, bool) {
	if o == nil || IsNil(o.OAuthId) {
		return nil, false
	}
	return o.OAuthId, true
}

// HasOAuthId returns a boolean if a field has been set.
func (o *SalesforceDestinationAllOf) HasOAuthId() bool {
	if o != nil && !IsNil(o.OAuthId) {
		return true
	}

	return false
}

// SetOAuthId gets a reference to the given int32 and assigns it to the OAuthId field.
func (o *SalesforceDestinationAllOf) SetOAuthId(v int32) {
	o.OAuthId = &v
}

// GetInstance returns the Instance field value if set, zero value otherwise.
func (o *SalesforceDestinationAllOf) GetInstance() string {
	if o == nil || IsNil(o.Instance) {
		var ret string
		return ret
	}
	return *o.Instance
}

// GetInstanceOk returns a tuple with the Instance field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SalesforceDestinationAllOf) GetInstanceOk() (*string, bool) {
	if o == nil || IsNil(o.Instance) {
		return nil, false
	}
	return o.Instance, true
}

// HasInstance returns a boolean if a field has been set.
func (o *SalesforceDestinationAllOf) HasInstance() bool {
	if o != nil && !IsNil(o.Instance) {
		return true
	}

	return false
}

// SetInstance gets a reference to the given string and assigns it to the Instance field.
func (o *SalesforceDestinationAllOf) SetInstance(v string) {
	o.Instance = &v
}

// GetApiVersion returns the ApiVersion field value if set, zero value otherwise.
func (o *SalesforceDestinationAllOf) GetApiVersion() string {
	if o == nil || IsNil(o.ApiVersion) {
		var ret string
		return ret
	}
	return *o.ApiVersion
}

// GetApiVersionOk returns a tuple with the ApiVersion field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SalesforceDestinationAllOf) GetApiVersionOk() (*string, bool) {
	if o == nil || IsNil(o.ApiVersion) {
		return nil, false
	}
	return o.ApiVersion, true
}

// HasApiVersion returns a boolean if a field has been set.
func (o *SalesforceDestinationAllOf) HasApiVersion() bool {
	if o != nil && !IsNil(o.ApiVersion) {
		return true
	}

	return false
}

// SetApiVersion gets a reference to the given string and assigns it to the ApiVersion field.
func (o *SalesforceDestinationAllOf) SetApiVersion(v string) {
	o.ApiVersion = &v
}

// GetObject returns the Object field value if set, zero value otherwise.
func (o *SalesforceDestinationAllOf) GetObject() string {
	if o == nil || IsNil(o.Object) {
		var ret string
		return ret
	}
	return *o.Object
}

// GetObjectOk returns a tuple with the Object field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SalesforceDestinationAllOf) GetObjectOk() (*string, bool) {
	if o == nil || IsNil(o.Object) {
		return nil, false
	}
	return o.Object, true
}

// HasObject returns a boolean if a field has been set.
func (o *SalesforceDestinationAllOf) HasObject() bool {
	if o != nil && !IsNil(o.Object) {
		return true
	}

	return false
}

// SetObject gets a reference to the given string and assigns it to the Object field.
func (o *SalesforceDestinationAllOf) SetObject(v string) {
	o.Object = &v
}

func (o SalesforceDestinationAllOf) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o SalesforceDestinationAllOf) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.OAuthId) {
		toSerialize["o_auth_id"] = o.OAuthId
	}
	if !IsNil(o.Instance) {
		toSerialize["instance"] = o.Instance
	}
	if !IsNil(o.ApiVersion) {
		toSerialize["api_version"] = o.ApiVersion
	}
	if !IsNil(o.Object) {
		toSerialize["object"] = o.Object
	}
	return toSerialize, nil
}

type NullableSalesforceDestinationAllOf struct {
	value *SalesforceDestinationAllOf
	isSet bool
}

func (v NullableSalesforceDestinationAllOf) Get() *SalesforceDestinationAllOf {
	return v.value
}

func (v *NullableSalesforceDestinationAllOf) Set(val *SalesforceDestinationAllOf) {
	v.value = val
	v.isSet = true
}

func (v NullableSalesforceDestinationAllOf) IsSet() bool {
	return v.isSet
}

func (v *NullableSalesforceDestinationAllOf) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableSalesforceDestinationAllOf(val *SalesforceDestinationAllOf) *NullableSalesforceDestinationAllOf {
	return &NullableSalesforceDestinationAllOf{value: val, isSet: true}
}

func (v NullableSalesforceDestinationAllOf) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableSalesforceDestinationAllOf) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
